<?php
if(count(get_included_files()) ==1) exit("Direct access not permitted.");
if(isset($_POST['ikdata'])){
if (!isset($_SESSION)) session_start();
$db=pDatabase::getInstance();
$datafungsi=[
	"getTabel"=>"getTabel",
	"datacari01"=>"datacari01",
	"inputmastercatatan"=>"inputmastercatatan",
	"editmastercatatan"=>"editmastercatatan",
	"hapusData"=>"hapusData",
	"setstatus"=>"setstatus"
];

if(!$db->ceckmodule($cl)) exit;
	$data=$_POST['ikdata'];
	$ex=false;
	if(isset($datafungsi[$data[0]])) $ex=$datafungsi[$data[0]]($data);
	echo $ex;
}else{
	echo false;
}

function gethalaman($qr,$dt,$jumlah){
	$db=pDatabase::getInstance();
	
	$rs=$db->loadAssoc($qr,$dt);
	
	$total=1;
	if(isset($rs['total'])){
		$total=ceil($rs['total']/$jumlah);
	}
	if($total==0){
		return 1;
	}else{
		return $total;
	}
}

function datacari01($data=array())
{
	$mode=0;
	$kunci=array("nama","kategori");
	$alias=array("Nama Catatan","Kategori");
	$kolom=array("t1.nama","t2.nama");
	$jenis=array();
	
	$hasil=array("kunci"=>$kunci,"kolom"=>$kolom,"alias"=>$alias,"jenis"=>$jenis);
	if(sizeof($data)>0){
		$mode=$data[1];
	}
	if($mode==0){
		return $hasil;
	}else{
		return json_encode($hasil);
	}
}

function getTabel($data){
	$db=pDatabase::getInstance();
	$cari=$data[3];
	$arrcr=explode("&", $cari);
	
	$datapush=array();
	$wh="";
	if(sizeof($arrcr)>0){
		$arrkunci0=explode("=", $arrcr[0]);
		if(sizeof($arrcr)==1 && sizeof($arrkunci0)==1){
			$cr="%$cari%";
			$wh.="AND t1.nama LIKE ? ";
			array_push($datapush,$cr);
		}else{
			$datacari=$db->datacari(datacari01(),$arrcr);
			$datapush=$datacari['datapush'];
			$wh=$datacari['query'];
		}
	}
	
	$qt="SELECT COUNT(*) as total FROM tb_master_catatan as t1
		inner join tb_master_catatan_kategori as t2 on t1.idkategori=t2.id
		WHERE t1.id>0 ".$wh;
		
	$total=gethalaman($qt,$datapush,$data[2]);
	array_push($datapush,$data[1],$data[2]);
	
	$query="SELECT t1.`id`,
			t1.`idkategori`,
			t1.`nama`,
			t1.`catatan`,
			t1.`status`,
			t2.nama as kategori,
			$total as halaman FROM tb_master_catatan as t1
		inner join tb_master_catatan_kategori as t2 on t1.idkategori=t2.id
		WHERE t1.id>0 ".$wh."
		ORDER BY t1.id ASC LIMIT ?,?";
	$rs=$db->jsonData($query,$datapush);
	
	return $rs;
}
function inputmastercatatan($data){
	$db=pDatabase::getInstance();
	
	global $config_data;
	$catatan=strip_tags($data['catatan'],$config_data['tag_catatan']);
	
	$datainput=[
		"nama"=>$data['nama'],
		"idkategori"=>$data['idkategori'],
		"catatan"=>$catatan
	];
	$rs=$db->insert("tb_master_catatan",$datainput,0,1);
	return $rs;
}
function editmastercatatan($data){
	$db=pDatabase::getInstance();
	global $config_data;
	$catatan=strip_tags($data['catatan'],$config_data['tag_catatan']);
	
	$datainput=[
		"nama"=>$data['nama'],
		"idkategori"=>$data['idkategori'],
		"catatan"=>$catatan
	];
	$rs=$db->update("tb_master_catatan",$datainput,"id",$data['id'],1);
	return $rs;
}
function hapusData($data){
	$db=pDatabase::getInstance();
	
	$query="DELETE FROM tb_master_catatan WHERE id=?";
	$rs=$db->query($query,array($data['id']));
	return $rs;
}
function setstatus($data){
	$db=pDatabase::getInstance();
	$datainput=[
		"status"=>$data['status']
	];
	$rs=$db->update("tb_master_catatan",$datainput,"id",$data['id']);
	return $rs;
}
?>